unit ufile;

interface
uses Forms, SysUtils, Windows, Dialogs;

function SetTextByVyska(vyska: Integer; kriz: Boolean): String;
function SetTextByDelka(delka: Double): String;
function GetVyskaByText(vyskatext: String): Integer;
function GetDelkaByText(delkatext: String): Double;
procedure AnalyzujVstup(soubor: String);
procedure UlozitZaznam(soubor: String);

implementation
uses uwin, uvars;
procedure UlozitZaznam(soubor: String);
var f: TextFile;
    i: Integer;
begin
 AssignFile(f, soubor);
 try
  Rewrite(f);
  WriteLn(f, IntToStr(varDOBY) + '/4');
  // Ukladani not
  for i := 0 to ZaznamDelka - 1 do begin
   WriteLn(f, SetTextByVyska(Zaznam[i].vyska, Zaznam[i].kriz) + ' ' + SetTextByDelka(Zaznam[i].delka));
  end;
  CloseFile(f);
 except
    MessageBox(win.Handle, 'Nelze uloit zvolen soubor', 'Chyba', MB_ICONERROR);
 end;

end;

procedure AnalyzujVstup(soubor: String);
var f: TextFile;
    line: String; // ctena radka
    xvyska: String; //
    xdelka: String; // Vlastnosti prave ctene noty
    i: Integer; // Index pro vymaz
    mpos: Integer; // Pozice mezery v radce
begin
try


 //******* Vymaz not
 for i := 0 to ZaznamDelka do
 begin
  if Zaznam[i] <> nil then
  Zaznam[i].Free;
 end;
 ZaznamDelka := 0;

 AssignFile(f, soubor);
 Reset(f);
 //************** Prvni radka
 ReadLn(f, line);
 if line = '3/4' then begin DobyBitmap := Takt34; varDOBY := 3; end
 else if line = '4/4' then begin  DobyBitmap := Takt44; varDOBY := 4; end
 else if line = '5/4' then begin DobyBitmap := Takt54; varDOBY := 5; end
 else raise Exception.Create('Chyba v prvni radce');
 //************* Noty
 while not eof(f) do begin
  ReadLn(f, line);
  mpos := Pos(' ', line);
  xvyska := Copy(line, 0, mpos - 1);
  xdelka := Copy(line, mpos + 1, Length(line));
  Zaznam[ZaznamDelka] := TNota.Create;
  Zaznam[ZaznamDelka].vyska := GetVyskaByText(xvyska);
  if Length(xvyska) > 1 then
  Zaznam[ZaznamDelka].kriz := true
  else
  Zaznam[ZaznamDelka].kriz := false;
  Zaznam[ZaznamDelka].delka := GetDelkaByText(xdelka);
  ZaznamDelka := ZaznamDelka + 1;
 end;
 CloseFile(f);
except
 MessageBox(win.Handle, 'Nelze nast zvolen soubor', 'Chyba', MB_ICONERROR);
 CloseFile(f);
end;
end;

function GetVyskaByText(vyskatext: String): Integer;
begin
     if vyskatext = 'C' then Result := pC
else if vyskatext = 'Cis' then Result := pC
else if vyskatext = 'D' then Result := pD
else if vyskatext = 'Dis' then Result := pD
else if vyskatext = 'E' then Result := pE
else if vyskatext = 'F' then Result := pF
else if vyskatext = 'Fis' then Result := pF
else if vyskatext = 'G' then Result := pG
else if vyskatext = 'Gis' then Result := pG
else if vyskatext = 'A' then Result := pA
else if vyskatext = 'Ais' then Result := pA
else if vyskatext = 'H' then Result := pH
else if vyskatext = 'c' then Result := ppc
else if vyskatext = 'cis' then Result := ppc
else if vyskatext = 'd' then Result := ppd
else if vyskatext = 'dis' then Result := ppd
else if vyskatext = 'e' then Result := ppe
else if vyskatext = 'f' then Result := ppf
else if vyskatext = 'fis' then Result := ppf
else if vyskatext = 'g' then Result := ppg
else if vyskatext = 'gis' then Result := ppg
else if vyskatext = 'a' then Result := ppa
else if vyskatext = 'ais' then Result := ppa
else if vyskatext = 'h' then Result := pph
else if vyskatext = 'pomlka' then Result := 10000
else MessageBox(win.Handle, 'Nkter vka nebyla zadna sprvn.', 'Chyba', MB_ICONERROR);
end;

function SetTextByVyska(vyska: Integer; kriz: Boolean): String;
begin
 case vyska of
  pC: Result := 'C';
  pD: Result := 'D';
  pE: Result := 'E';
  pF: Result := 'F';
  pG: Result := 'G';
  pA: Result := 'A';
  pH: Result := 'H';
  ppc: Result := 'c';
  ppd: Result := 'd';
  ppe: Result := 'e';
  ppf: Result := 'f';
  ppg: Result := 'g';
  ppa: Result := 'a';
  pph: Result := 'h';
  10000: Result := 'pomlka';
 end;
 if (Result <> 'pomlka') and (kriz = true) then Result := Result + 'is';

end;

function GetDelkaByText(delkatext: String): Double;
begin
     if delkatext = '0.5' then Result := 0.5
else if delkatext = '1' then Result := 1
else if delkatext = '1.5' then Result := 1.5
else if delkatext = '2' then Result := 2
else if delkatext = '3' then Result := 3
else if delkatext = '4' then Result := 4
else MessageBox(win.Handle, 'Nkter dlka noty nebyla zadna sprvn.', 'Chyba', MB_ICONERROR);
end;

function SetTextByDelka(delka: Double): String;
begin
     if delka = 0.5 then Result := '0.5'
else if delka = 1 then Result := '1'
else if delka = 1.5 then Result := '1.5'
else if delka = 2 then Result := '2'
else if delka = 3 then Result := '3'
else if delka = 4 then Result := '4';
end;

end.
